#include    <exec/types.h>
#include    <string.h>

#include    "View_define.h"
/* These are HDF header files. The dfproto.h file I made myself */
#include    <hdf/dfproto.h>
#include    <hdf/df.h>
#include    "ViewProtos.h"

#define MAXRANK 10

int rank;

/* gets image size from HDF file */
int
getDataSize( char *filename, int *width, int *height,
               float32 *min, float32 *max)
{
   int ret;
   int ispalette;
   int32 dimsizes[MAXRANK];
   
   
   if( (ret=DFR8getdims(filename, width, height, &ispalette)) == -1)
      return(ret);
   
   ret = DFSDgetdims(filename,&rank,dimsizes,MAXRANK);
   ret = DFSDgetmaxmin(min,max);
   if(ret==-1) { *max=0.0; *min=0.0; }
   return(ispalette);
}



/* gets the actual image from the file */

int getData(unsigned char *image, int width, int height, int ispal,
            char *filename)
{
   int ret;
   unsigned char palette[768];
   
   if( (ret=DFR8getimage(filename,image,width,height,palette)) == -1)
      return(ret);
      
   if(ispal==1) setPal(palette);   
   
   return(1);
}
      
